/* This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this file,
 * You can obtain one at http://mozilla.org/MPL/2.0/. */

"use strict";

Components.utils.import("resource://gre/modules/XPCOMUtils.jsm");
XPCOMUtils.defineLazyModuleGetter(this, "Services", "resource://gre/modules/Services.jsm");

this.EXPORTED_SYMBOLS = ["AppConstants"];

// Immutable for export.
this.AppConstants = Object.freeze({
  // See this wiki page for more details about channel specific build
  // defines: https://wiki.mozilla.org/Platform/Channel-specific_build_defines
  NIGHTLY_BUILD:
//@line 20 "/builddir/build/BUILD/gecko-dev-042b84a/toolkit/modules/AppConstants.jsm"
  true,
//@line 24 "/builddir/build/BUILD/gecko-dev-042b84a/toolkit/modules/AppConstants.jsm"

  RELEASE_OR_BETA:
//@line 29 "/builddir/build/BUILD/gecko-dev-042b84a/toolkit/modules/AppConstants.jsm"
  false,
//@line 31 "/builddir/build/BUILD/gecko-dev-042b84a/toolkit/modules/AppConstants.jsm"

  ACCESSIBILITY:
//@line 34 "/builddir/build/BUILD/gecko-dev-042b84a/toolkit/modules/AppConstants.jsm"
  true,
//@line 38 "/builddir/build/BUILD/gecko-dev-042b84a/toolkit/modules/AppConstants.jsm"

  // Official corresponds, roughly, to whether this build is performed
  // on Mozilla's continuous integration infrastructure. You should
  // disable developer-only functionality when this flag is set.
  MOZILLA_OFFICIAL:
//@line 46 "/builddir/build/BUILD/gecko-dev-042b84a/toolkit/modules/AppConstants.jsm"
  false,
//@line 48 "/builddir/build/BUILD/gecko-dev-042b84a/toolkit/modules/AppConstants.jsm"

  MOZ_OFFICIAL_BRANDING:
//@line 53 "/builddir/build/BUILD/gecko-dev-042b84a/toolkit/modules/AppConstants.jsm"
  false,
//@line 55 "/builddir/build/BUILD/gecko-dev-042b84a/toolkit/modules/AppConstants.jsm"

  MOZ_DEV_EDITION:
//@line 60 "/builddir/build/BUILD/gecko-dev-042b84a/toolkit/modules/AppConstants.jsm"
  false,
//@line 62 "/builddir/build/BUILD/gecko-dev-042b84a/toolkit/modules/AppConstants.jsm"

  MOZ_SERVICES_HEALTHREPORT:
//@line 67 "/builddir/build/BUILD/gecko-dev-042b84a/toolkit/modules/AppConstants.jsm"
  false,
//@line 69 "/builddir/build/BUILD/gecko-dev-042b84a/toolkit/modules/AppConstants.jsm"

  MOZ_DATA_REPORTING:
//@line 74 "/builddir/build/BUILD/gecko-dev-042b84a/toolkit/modules/AppConstants.jsm"
  false,
//@line 76 "/builddir/build/BUILD/gecko-dev-042b84a/toolkit/modules/AppConstants.jsm"

  MOZ_SANDBOX:
//@line 79 "/builddir/build/BUILD/gecko-dev-042b84a/toolkit/modules/AppConstants.jsm"
  true,
//@line 83 "/builddir/build/BUILD/gecko-dev-042b84a/toolkit/modules/AppConstants.jsm"

  MOZ_CONTENT_SANDBOX:
//@line 86 "/builddir/build/BUILD/gecko-dev-042b84a/toolkit/modules/AppConstants.jsm"
  true,
//@line 90 "/builddir/build/BUILD/gecko-dev-042b84a/toolkit/modules/AppConstants.jsm"

  MOZ_TELEMETRY_REPORTING:
//@line 95 "/builddir/build/BUILD/gecko-dev-042b84a/toolkit/modules/AppConstants.jsm"
  false,
//@line 97 "/builddir/build/BUILD/gecko-dev-042b84a/toolkit/modules/AppConstants.jsm"

  MOZ_TELEMETRY_ON_BY_DEFAULT:
//@line 102 "/builddir/build/BUILD/gecko-dev-042b84a/toolkit/modules/AppConstants.jsm"
  false,
//@line 104 "/builddir/build/BUILD/gecko-dev-042b84a/toolkit/modules/AppConstants.jsm"

  MOZ_SERVICES_CLOUDSYNC:
//@line 109 "/builddir/build/BUILD/gecko-dev-042b84a/toolkit/modules/AppConstants.jsm"
  false,
//@line 111 "/builddir/build/BUILD/gecko-dev-042b84a/toolkit/modules/AppConstants.jsm"

  MOZ_UPDATER:
//@line 116 "/builddir/build/BUILD/gecko-dev-042b84a/toolkit/modules/AppConstants.jsm"
  false,
//@line 118 "/builddir/build/BUILD/gecko-dev-042b84a/toolkit/modules/AppConstants.jsm"

  MOZ_SWITCHBOARD:
//@line 123 "/builddir/build/BUILD/gecko-dev-042b84a/toolkit/modules/AppConstants.jsm"
  false,
//@line 125 "/builddir/build/BUILD/gecko-dev-042b84a/toolkit/modules/AppConstants.jsm"

  MOZ_WEBRTC:
//@line 128 "/builddir/build/BUILD/gecko-dev-042b84a/toolkit/modules/AppConstants.jsm"
  true,
//@line 132 "/builddir/build/BUILD/gecko-dev-042b84a/toolkit/modules/AppConstants.jsm"

  MOZ_WIDGET_GTK:
//@line 135 "/builddir/build/BUILD/gecko-dev-042b84a/toolkit/modules/AppConstants.jsm"
  true,
//@line 139 "/builddir/build/BUILD/gecko-dev-042b84a/toolkit/modules/AppConstants.jsm"

//@line 141 "/builddir/build/BUILD/gecko-dev-042b84a/toolkit/modules/AppConstants.jsm"
  MOZ_B2G:
//@line 145 "/builddir/build/BUILD/gecko-dev-042b84a/toolkit/modules/AppConstants.jsm"
  false,
//@line 147 "/builddir/build/BUILD/gecko-dev-042b84a/toolkit/modules/AppConstants.jsm"

  XP_UNIX:
//@line 150 "/builddir/build/BUILD/gecko-dev-042b84a/toolkit/modules/AppConstants.jsm"
  true,
//@line 154 "/builddir/build/BUILD/gecko-dev-042b84a/toolkit/modules/AppConstants.jsm"

//@line 157 "/builddir/build/BUILD/gecko-dev-042b84a/toolkit/modules/AppConstants.jsm"
  platform:
//@line 159 "/builddir/build/BUILD/gecko-dev-042b84a/toolkit/modules/AppConstants.jsm"
  "linux",
//@line 173 "/builddir/build/BUILD/gecko-dev-042b84a/toolkit/modules/AppConstants.jsm"

  isPlatformAndVersionAtLeast(platform, version) {
    let platformVersion = Services.sysinfo.getProperty("version");
    return platform == this.platform &&
           Services.vc.compare(platformVersion, version) >= 0;
  },

  isPlatformAndVersionAtMost(platform, version) {
    let platformVersion = Services.sysinfo.getProperty("version");
    return platform == this.platform &&
           Services.vc.compare(platformVersion, version) <= 0;
  },

  MOZ_CRASHREPORTER:
//@line 190 "/builddir/build/BUILD/gecko-dev-042b84a/toolkit/modules/AppConstants.jsm"
  false,
//@line 192 "/builddir/build/BUILD/gecko-dev-042b84a/toolkit/modules/AppConstants.jsm"

  MOZ_VERIFY_MAR_SIGNATURE:
//@line 197 "/builddir/build/BUILD/gecko-dev-042b84a/toolkit/modules/AppConstants.jsm"
  false,
//@line 199 "/builddir/build/BUILD/gecko-dev-042b84a/toolkit/modules/AppConstants.jsm"

  MOZ_MAINTENANCE_SERVICE:
//@line 204 "/builddir/build/BUILD/gecko-dev-042b84a/toolkit/modules/AppConstants.jsm"
  false,
//@line 206 "/builddir/build/BUILD/gecko-dev-042b84a/toolkit/modules/AppConstants.jsm"

  E10S_TESTING_ONLY:
//@line 209 "/builddir/build/BUILD/gecko-dev-042b84a/toolkit/modules/AppConstants.jsm"
  true,
//@line 213 "/builddir/build/BUILD/gecko-dev-042b84a/toolkit/modules/AppConstants.jsm"

  DEBUG:
//@line 218 "/builddir/build/BUILD/gecko-dev-042b84a/toolkit/modules/AppConstants.jsm"
  false,
//@line 220 "/builddir/build/BUILD/gecko-dev-042b84a/toolkit/modules/AppConstants.jsm"

  ASAN:
//@line 225 "/builddir/build/BUILD/gecko-dev-042b84a/toolkit/modules/AppConstants.jsm"
  false,
//@line 227 "/builddir/build/BUILD/gecko-dev-042b84a/toolkit/modules/AppConstants.jsm"

  MOZ_B2G_RIL:
//@line 232 "/builddir/build/BUILD/gecko-dev-042b84a/toolkit/modules/AppConstants.jsm"
  false,
//@line 234 "/builddir/build/BUILD/gecko-dev-042b84a/toolkit/modules/AppConstants.jsm"

  MOZ_GRAPHENE:
//@line 239 "/builddir/build/BUILD/gecko-dev-042b84a/toolkit/modules/AppConstants.jsm"
  false,
//@line 241 "/builddir/build/BUILD/gecko-dev-042b84a/toolkit/modules/AppConstants.jsm"

  MOZ_SYSTEM_NSS:
//@line 244 "/builddir/build/BUILD/gecko-dev-042b84a/toolkit/modules/AppConstants.jsm"
  true,
//@line 248 "/builddir/build/BUILD/gecko-dev-042b84a/toolkit/modules/AppConstants.jsm"

  MOZ_PLACES:
//@line 253 "/builddir/build/BUILD/gecko-dev-042b84a/toolkit/modules/AppConstants.jsm"
  false,
//@line 255 "/builddir/build/BUILD/gecko-dev-042b84a/toolkit/modules/AppConstants.jsm"

  MOZ_REQUIRE_SIGNING:
//@line 260 "/builddir/build/BUILD/gecko-dev-042b84a/toolkit/modules/AppConstants.jsm"
  false,
//@line 262 "/builddir/build/BUILD/gecko-dev-042b84a/toolkit/modules/AppConstants.jsm"

  INSTALL_COMPACT_THEMES:
//@line 265 "/builddir/build/BUILD/gecko-dev-042b84a/toolkit/modules/AppConstants.jsm"
  true,
//@line 269 "/builddir/build/BUILD/gecko-dev-042b84a/toolkit/modules/AppConstants.jsm"

  MENUBAR_CAN_AUTOHIDE:
//@line 272 "/builddir/build/BUILD/gecko-dev-042b84a/toolkit/modules/AppConstants.jsm"
  true,
//@line 276 "/builddir/build/BUILD/gecko-dev-042b84a/toolkit/modules/AppConstants.jsm"

  CAN_DRAW_IN_TITLEBAR:
//@line 281 "/builddir/build/BUILD/gecko-dev-042b84a/toolkit/modules/AppConstants.jsm"
  false,
//@line 283 "/builddir/build/BUILD/gecko-dev-042b84a/toolkit/modules/AppConstants.jsm"

  MOZ_ANDROID_HISTORY:
//@line 288 "/builddir/build/BUILD/gecko-dev-042b84a/toolkit/modules/AppConstants.jsm"
  false,
//@line 290 "/builddir/build/BUILD/gecko-dev-042b84a/toolkit/modules/AppConstants.jsm"

  MOZ_TOOLKIT_SEARCH:
//@line 293 "/builddir/build/BUILD/gecko-dev-042b84a/toolkit/modules/AppConstants.jsm"
  true,
//@line 297 "/builddir/build/BUILD/gecko-dev-042b84a/toolkit/modules/AppConstants.jsm"

  MOZ_GECKO_PROFILER:
//@line 300 "/builddir/build/BUILD/gecko-dev-042b84a/toolkit/modules/AppConstants.jsm"
  true,
//@line 304 "/builddir/build/BUILD/gecko-dev-042b84a/toolkit/modules/AppConstants.jsm"

  MOZ_ANDROID_ACTIVITY_STREAM:
//@line 309 "/builddir/build/BUILD/gecko-dev-042b84a/toolkit/modules/AppConstants.jsm"
  false,
//@line 311 "/builddir/build/BUILD/gecko-dev-042b84a/toolkit/modules/AppConstants.jsm"

  DLL_PREFIX: "lib",
  DLL_SUFFIX: ".so",

  MOZ_APP_NAME: "bluegriffon",
  MOZ_APP_VERSION: "3.1",
  MOZ_APP_VERSION_DISPLAY: "3.1",
  MOZ_BUILD_APP: "bluegriffon",
  MOZ_MACBUNDLE_NAME: "BlueGriffon.app",
  MOZ_UPDATE_CHANNEL: "default",
  INSTALL_LOCALE: "en-US",
  MOZ_WIDGET_TOOLKIT: "gtk3",
  ANDROID_PACKAGE_NAME: "org.mozilla.bluegriffon",
  MOZ_B2G_VERSION: "1.0.0",
  MOZ_B2G_OS_NAME: "",

  DEBUG_JS_MODULES: "",

  // URL to the hg revision this was built from (e.g.
  // "https://hg.mozilla.org/mozilla-central/rev/6256ec9113c1")
  // On unofficial builds, this is an empty string.
//@line 335 "/builddir/build/BUILD/gecko-dev-042b84a/toolkit/modules/AppConstants.jsm"
  SOURCE_REVISION_URL: "",

  HAVE_USR_LIB64_DIR:
//@line 341 "/builddir/build/BUILD/gecko-dev-042b84a/toolkit/modules/AppConstants.jsm"
    false,
//@line 343 "/builddir/build/BUILD/gecko-dev-042b84a/toolkit/modules/AppConstants.jsm"

  HAVE_SHELL_SERVICE:
//@line 346 "/builddir/build/BUILD/gecko-dev-042b84a/toolkit/modules/AppConstants.jsm"
    true,
//@line 350 "/builddir/build/BUILD/gecko-dev-042b84a/toolkit/modules/AppConstants.jsm"
});
